=== debian/changelog ===
llvm-toolchain-13 (1:13.0.0~+rc4-1ubuntu1) impish; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Build using GCC 10 on armhf. No idea about the build failure with GCC 11
      yet.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 Sep 2021 17:11:32 +0200

llvm-toolchain-13 (1:13.0.0~+rc4-1) unstable; urgency=medium

  * New testing release
  * Ship clang-repl
    See https://reviews.llvm.org/D106813
  * Replace make by ninja for the build process
    It is now more tested than make by upstream
    And it is supposed to be faster
    Removed openmp/bootstrap-with-openmp-version-export-missing.diff
    as it seems that the ninja move fixed it

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 18 Sep 2021 19:30:47 +0200

llvm-toolchain-12 (1:12.0.1-9) unstable; urgency=medium

  * Replace make by ninja for the build process
    It is now more tested than make by upstream
    And it is supposed to be faster
    Removed openmp/bootstrap-with-openmp-version-export-missing.diff
    as it seems that the ninja move fixed it

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 18 Sep 2021 11:03:29 +0200
